<template>
  <div>
    <div class="title">Старый ответственный</div>
    <div class="row">
      <div class="col-xs-12">
        <ObInput
          label="Организация"
          :value="order[order.isSuborder ? 'clientTitle' : 'contractorTitle']"
          :readonly="true"
        />
      </div>
    </div>
    <div class="row">
      <div class="col-xs-6">
        <ObInput
          label="ФИО"
          :value="order[order.isSuborder ? 'clientLogistTitle' : 'logistTitle']"
          :readonly="true"
        />
      </div>
      <div class="col-xs-6">
        <ObInput
          label="Контактный телефон"
          :value="order[order.isSuborder ? 'clientPhone' : 'logistPhone']"
          mask="+7 (999) 999-9999"
          :readonly="true"
        />
      </div>
    </div>

    <div class="title">Новый ответственный</div>
    <div class="row">
      <div class="col-xs-6">
        <ObSelect
          ref="usersList"
          label="ФИО"
          :value="formData.logistUuid"
          :remote-opt="{
            method: isGetAllUsers ? getAllUsers : getUsersList,
            loadEvent: 'open'
          }"
          :remote-trigger="String(isGetAllUsers)"
          :is-standart="true"
          :disabled="!isNew"
          placeholder="Выберите ответственного"
          :itemBottom="selectItemBottom"
          :is-close-on-item-bottom-click="false"
          class="mt30 mb20"
          data-qa="contractorSelect"
          @bottom="showAllUsers"
          @input="onChangeField('logistUuid', $event)"
          @selected="onUserSelect"
        />
      </div>
      <div class="col-xs-6">
        <ObInput
          label="Контактный телефон"
          :value="formData.newLogistPhone"
          mask="+7 (999) 999-9999"
          :readonly="true"
        />
      </div>
    </div>
    <div class="row">
      <div class="col-xs-12">
        <ObTextarea
          :value="formData.comment"
          label="Комментарий"
          placeholder="Добавьте комментарий"
          :readonly="(!isNew && !isEditable)"
          @input="onChangeField('comment', $event)"
        />
      </div>
    </div>
    <template v-if="((!formData.fileUuids || !formData.fileUuids.length) && !isNew && !isEditable)">
      <div class="title">Нет прикрепленных файлов</div>
    </template>
    <template v-else>
      <div class="title">Прикрепленные файлы</div>
      <ObUploader
          ref="uploader"
          multiple
          :value="currentFile"
          data-qa="uploader"
          :is-read-only="(!isNew && !isEditable)"
          :upload-method="uploadMethod"
          @process-start="startUploadFiles"
          @change="onUploadHandler"
      />
    </template>
  </div>
</template>

<script>
import api from "@/api"
import ObInput from 'common-components/src/obComponents/obInput'
import ObSelect from 'common-components/src/obComponents/obSelect'
import ObTextarea from 'common-components/src/obComponents/obTextarea'
import ObUploader from 'common-components/src/obComponents/obUploader'
import { mapGetters } from "vuex"

export default {
  name: 'logistEventForm',
  components: {
    ObInput,
    ObSelect,
    ObTextarea,
    ObUploader
  },
  props: {
    formData: {
      type: Object,
      default: () => {}
    },
    order: {
      type: Object,
      default: () => {}
    },
    isEditable: {
      type: Boolean,
      default: false
    }
  },
  data () {
    return {
      selectedUser: {},
      isGetAllUsers: false
    }
  },
  watch: {
    'formData.fileUuids': {
      handler (value) {
        if (!value) {
          this.$refs.uploader && this.$refs.uploader.clearFiles()
        }
      },
      deep: true
    },
    formData () {
      if (this.isGetAllUsers) {
        this.isGetAllUsers = false
      }
    }
  },
  computed: {
    ...mapGetters({
      participantUuid: 'user/participantUuid'
    }),
    isNew () {
      return Boolean(!this.formData.uuid)
    },
    uploadMethod () {
      return api.files.postFile
    },
    currentFile () {
      if (this.formData.fileUuids && this.formData.fileUuids !== 'loading') {
        return this.formData.fileUuids.map((uuid) => {
          return { uuid: uuid }
        })
      }

      return null
    },
    selectItemBottom () {
      return this.isGetAllUsers ? null : { title: `Показать весь список` }
    },
  },
  methods: {
    startUploadFiles () {
      this.formData.fileUuids = 'loading'
    },
    async onUploadHandler (data) {
      data = data.map(file => file.uuid)

      this.onChangeField('fileUuids', data)
    },
    onChangeField (path, value) {
      this.$emit('change-field', { path, value })
    },
    async getUsersList () {
      const isSuborder = this.order.isSuborder
      const { clientUuid, contractorUuid, uuid } = this.order

      if (isSuborder) {
        return await api.orderProcess.getSuborderLogisticians({ uuid })
      } else {
        return await api.orderProcess.getOrderLogisticians({ clientUuid, contractorUuid })
      }
    },
    showAllUsers () {
      this.isGetAllUsers = true

      setTimeout(() => {
        this.$refs.usersList.toggle()
      }, 300)
    },
    async getAllUsers () {

      return await api.orderProcess.getPartricipantUsers({ contractorUuid: this.participantUuid })
    },
    onUserSelect (data) {
      if (data) {
        this.$emit('change-field', { path: 'newLogistPhone', value: data.phone })
      }
    }
  }
}
</script>
